diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/rclib/install_rclib v15.6301-amd64/pop/packages/rclib/install_rclib
--- pp0/v15.61-amd64/pop/packages/rclib/install_rclib	2000-03-07 17:56:11.000000000 -0500
+++ v15.6301-amd64/pop/packages/rclib/install_rclib	2009-07-03 21:43:17.000000000 -0400
@@ -1,4 +1,8 @@
 #!/bin/sh
+##
+## NO LONGER NEEDED: 4 Jul 2009
+
+
 # $poplocal/local/rclib/install_rclib
 #   Aaron Sloman Last Modified:  7 Mar 2000
 #   (Name of file changed.)
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/teaching/auto/ttt.p v15.6301-amd64/pop/packages/teaching/auto/ttt.p
--- pp0/v15.61-amd64/pop/packages/teaching/auto/ttt.p	1996-02-17 10:17:56.000000000 -0500
+++ v15.6301-amd64/pop/packages/teaching/auto/ttt.p	2009-07-05 19:11:19.000000000 -0400
@@ -1,7 +1,7 @@
-/*  --- Copyright University of Sussex 1986.  All rights reserved. ---------
+/*  --- Copyright University of Sussex 2009.  All rights reserved. ---------
  >  File:           C.all/lib/auto/ttt.p
  >  Purpose:        typing tutor program
- >  Author:         Aaron Sloman 1979
+ >  Author:         Aaron Sloman 1979 (see revisions)
  >  Documentation:  TEACH * TTT
  >  Related Files:
  */
@@ -120,6 +120,8 @@
 dlocal count;
 
 	pr('Try this:\n');
+	;;; add a space to match ved's prompt character.
+	if vedediting then pr(' ') endif;
 	pr(l);
 	pr(newline);
 	readstrip() -> inchar;
@@ -133,6 +135,7 @@
 		pr('\ninstead of          : ');
 		pr(l);
 		pr('\nTry again\n');
+		if vedediting then pr(' ') endif;
 		pr(l);
 		pr(newline);
 		readstrip() ->inchar;
@@ -278,5 +281,8 @@
 
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Jul  6 2009
+	Altered printout if used in ved so that an extra space is used to make
+	output match what the user will type.
 --- A Sloman, Sep 1986 tidied and tabified
 */
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/teaching/lib/elizaprog.p v15.6301-amd64/pop/packages/teaching/lib/elizaprog.p
--- pp0/v15.61-amd64/pop/packages/teaching/lib/elizaprog.p	2007-04-19 15:43:50.000000000 -0400
+++ v15.6301-amd64/pop/packages/teaching/lib/elizaprog.p	2009-07-18 08:40:44.000000000 -0400
@@ -1,4 +1,4 @@
-/*  --- Copyright University of Sussex 2007.  All rights reserved. ---------
+/*  --- Copyright University of Sussex 2009.  All rights reserved. ---------
  >  File:           $usepop/pop/packages/teaching/lib/elizaprog.p
  >  Purpose:        Sussex Mini ELIZA programme
  >  Author:         Mostly A.Sloman 1978 (see revisions)
@@ -47,6 +47,8 @@
 
 global vars eliza_debug = false;
 
+global vars procedure eliza_output;
+
 
 lvars procedure inchar;   ;;; reassigned in eliza.
 
@@ -1359,7 +1361,7 @@
             ['what if you were' ??L2 ?]
             ['am I really not' ??L2 ?]
 			['Have you ever been' ??L2 ?]
-			['Being' ?LL2 'is not a good qualification for a therapist']
+			['Being' ?L2 'is not a good qualification for a therapist']
 			['i prefer not to be' ??L2]
             ['What, then, is' ??L2 ?]
 			['You are not good enough to be' ??L2]
@@ -1673,7 +1675,7 @@
 			['What or who can' ??L2?]
 			['What can be expected of' ??L1 ?]
 			['Will you ever' ??L2 ?]
-			['Did' ??L1 ?LL2 'last year?']
+			['Did' ??L1 ?L2 'last year?']
 			'The future isn\'t always like the past.'
 			['Can you say any more about' ??L1?]
 			['Can you' ??L2?]
@@ -2352,6 +2354,11 @@
 Good day what is your problem?\n\n'
 ;
 
+define global vars procedure eliza_output(answer);
+		ppr(answer);
+		pr(newline);
+enddefine;
+
 define eliza();
 	dlocal inchar, sentence, problem, cucharin, earlycount = 1;
 
@@ -2390,15 +2397,25 @@
 	readsentence() ->> problem -> sentence;
 	while true do
 		earlycount + 1 -> earlycount;
-		ppr(replyto(sentence,shuffle(eliza_rules) ->> eliza_rules));
-		pr(newline);
+		lvars answer;
+		replyto(sentence,shuffle(eliza_rules) ->> eliza_rules) -> answer;
+		;;; ppr(answer);
+		;;; pr(newline);
+		eliza_output(answer);
 		readsentence() -> sentence;
 	endwhile
 enddefine;
 
+pr('\n\nPlease type\n\n\s\s\seliza();\n\n');
+
 endsection;
 
 /*  --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Jul 18 2009
+		fixed a minor old bug -- local variable wrongly named
+--- Aaron Sloman, Jul 18 2009
+		Introduced procedure eliza_output to make it easy to change
+		how eliza responds.
 --- Aaron Sloman, Apr 14 2007
 	Copied over latest changes from online eliza
 	http://www.cs.bham.ac.uk/research/projects/cogaff/eliza/
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/teaching/lib/schema.p v15.6301-amd64/pop/packages/teaching/lib/schema.p
--- pp0/v15.61-amd64/pop/packages/teaching/lib/schema.p	1994-07-25 07:38:56.000000000 -0400
+++ v15.6301-amd64/pop/packages/teaching/lib/schema.p	2008-07-08 11:41:48.000000000 -0400
@@ -1,4 +1,4 @@
-/*	--- Copyright University of Sussex 1994.  All rights reserved. ---------
+/*	--- Copyright University of Sussex 2008.  All rights reserved. ---------
  >	File:			C.all/lib/lib/schema.p
  >	Purpose:		planning demonstration program?
  >	Author:			Steven Hardy, June 1982 (see revisions)
@@ -52,7 +52,7 @@
 	them -> same;
 	for X in same do if present(X) then remove(X) endif endfor;
 	database -> extra;
-	instance(S) -> database;
+	pattern_instance(S) -> database;
 	for X in same do if present(X) then remove(X) endif endfor;
 	database -> missing;
 enddefine;
@@ -92,6 +92,8 @@
 
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Jul  8 2008
+		Changed "instance" to "pattern_instance"
 --- John Williams, Jul 25 1994
 		dlocal instead of vars in procedure scheck (cf. BR isl-fr.4553)
 --- Andrew Law, Jul 22 1987 added correct documentation reference
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/teaching/lib/solver.p v15.6301-amd64/pop/packages/teaching/lib/solver.p
--- pp0/v15.61-amd64/pop/packages/teaching/lib/solver.p	1995-11-28 12:00:14.000000000 -0500
+++ v15.6301-amd64/pop/packages/teaching/lib/solver.p	2008-06-17 19:01:04.000000000 -0400
@@ -1,4 +1,4 @@
-/*  --- Copyright University of Sussex 1995.  All rights reserved. ---------
+/*  --- Copyright University of Sussex 2008.  All rights reserved. ---------
  >  File:           C.all/lib/lib/solver.p
  >  Purpose:        problem solver?
  >  Author:         S.Hardy, 1982 (see revisions)
@@ -16,6 +16,12 @@
 	report, schemalist, showplan, ShowTree, splice, splitup, startstrips, stripsstate,
 	treenumber, unique, uppr, verbose;
 
+global vars solverdelay;
+
+unless isinteger(solverdelay) then
+	50 -> solverdelay
+endunless;
+
 0 -> treenumber;
 true -> check;
 [[b1 on b2] [b2 on b3]] -> lastgoals;
@@ -81,7 +87,7 @@
 	endfor;
 	for schema on schemalist do
 		for datum on tl(schema) do
-			if instance(hd(hd(schema))) matches hd(hd(datum)) then
+			if pattern_instance(hd(hd(schema))) matches hd(hd(datum)) then
 				mishap('TWO SCHEMA HAVE MATCHING NAMES',
 					[%'THE SCHEMA NAMED', hd(hd(schema)),
 							'AND THE SCHEMA NAMED', hd(hd(datum))%])
@@ -181,6 +187,9 @@
 		ShowTree(treenumber, tree);
 		front(back(current)) -> front(current);
 		back(back(current)) -> back(current);
+		if isinteger(solverdelay) and solverdelay /== 0 then
+			syssleep(solverdelay)
+		endif;
 	endrepeat
 enddefine;
 
@@ -228,7 +237,7 @@
 	perform(plan);
 	prune([%for schema in schemalist do
 		forevery front(back(schema)) do
-			instance(front(schema)) -> action;
+			pattern_instance(front(schema)) -> action;
 			if unique(action, front(schema)) then action endif;
 		endforevery
 	  endfor%])
@@ -312,7 +321,7 @@
 				howdo([], goal) -> actions;
 				if actions = [] then 100000 -> result; return endif;
 				for newgoal
-					in instance(front(back(getschema(front(actions)))))
+					in pattern_instance(front(back(getschema(front(actions)))))
 				do
 					unless member(newgoal, considered) then
 						newgoal :: considered -> considered;
@@ -348,7 +357,7 @@
 			report('CANNOT REDUCE ' sys_>< front(back(current)));
 		else
 			for action in actions do
-				instance(front(back(getschema(action)))) -> goals;
+				pattern_instance(front(back(getschema(action)))) -> goals;
 				if achieves(plan, goals) then
 					[[* perform ^action]] -> node;
 					raise(raise(splice(tree)))
@@ -392,7 +401,7 @@
 		if unique(action, front(schema)) then
 			insert(
 				estimate(%[],
-					instance(front(back(getschema(action))))%) :: action,
+					pattern_instance(front(back(getschema(action))))%) :: action,
 				actions)
 				-> actions;
 			if estimating then
@@ -433,7 +442,7 @@
 	[] -> history;
 	for action in plan do
 		database :: history -> history;
-		instance(back(back(getschema(action)))) -> schema;
+		pattern_instance(back(back(getschema(action)))) -> schema;
 		allremove(front(schema));
 		alladd(front(back(schema)));
 	endfor;
@@ -492,7 +501,7 @@
 define perform(plan);
 	vars action, schema;
 	for action in plan do
-		instance(back(back(getschema(action)))) -> schema;
+		pattern_instance(back(back(getschema(action)))) -> schema;
 		allremove(front(schema));
 		alladd(front(back(schema)));
 	endfor
@@ -715,6 +724,9 @@
 		else
 			[%expand(current, plan, tree)%] <> stripsstate -> stripsstate;
 		endif;
+		if isinteger(solverdelay) and solverdelay /== 0 then
+			syssleep(solverdelay)
+		endif;
 	endrepeat
 enddefine;
 
@@ -802,6 +814,12 @@
 
 
 /*  --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Jun 18 2008
+		Also introduced solverdelay to slow down display: it's too fast
+		for modern computers otherwise.
+--- Aaron Sloman, Jun 17 2008
+		Replaced all occurrences of inst*ance with pattern_inst*ance,
+		because the former clashes with objectclass.
 --- John Williams, Nov 28 1995
 		Uses readstringline instead of readline due to problems with
 		the latter if strips commands are loaded with ved_lmr.
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/vedlatex/auto/findcite.p v15.6301-amd64/pop/packages/vedlatex/auto/findcite.p
--- pp0/v15.61-amd64/pop/packages/vedlatex/auto/findcite.p	2008-03-30 20:57:58.000000000 -0400
+++ v15.6301-amd64/pop/packages/vedlatex/auto/findcite.p	2008-05-05 05:12:43.000000000 -0400
@@ -109,7 +109,7 @@
 5000000 ->	popmemlim;
 
 ;;; These will be indicators of bibtex citations
-vars citewords = [cite nocite citea citep citet];
+vars citewords = [cite nocite citea citep citet citeauthor citeyear];
 
 ;;; convert bibtex types to lower case to simplify matching
 ;;; add more if needed
@@ -142,7 +142,8 @@
 	;;; Leave newlines on the stack. They will be put in a list	
 	;;; by the caller.
 	while next == newline then next; repeater() -> next endwhile;
-[next ^next] ==>
+	;;; [next ^next] ==>
+
 	;;; first non-newline should be item (e.g. "{" )
 	unless next == item then
 		mishap('Expecting ' >< item >< ' found: ' >< next, [])
@@ -781,6 +782,8 @@
 global vars findcite = true;
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, May  5 2008
+		Added \citeyear \citeauthor
 --- Aaron Sloman, Mar 31 2008
 		Removed spurious repeater in process_bib (filein)
 		Fixed item repeater in process_bib not to be upset by
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/vedlatex/auto/ved_bib.p v15.6301-amd64/pop/packages/vedlatex/auto/ved_bib.p
--- pp0/v15.61-amd64/pop/packages/vedlatex/auto/ved_bib.p	2003-02-08 09:57:39.000000000 -0500
+++ v15.6301-amd64/pop/packages/vedlatex/auto/ved_bib.p	2009-04-13 19:39:53.000000000 -0400
@@ -1,4 +1,4 @@
-/* --- Copyright University of Birmingham 2003. All rights reserved. ------
+/* --- Copyright University of Birmingham 2009. All rights reserved. ------
  > File:            $poplocal/local/ved_latex/auto/ved_bib.p
  > Linked to        $poplocal/local/auto/ved_bib.p
  > Purpose:         Create BIBTEX file entry
@@ -197,7 +197,7 @@
 		vedwordrightdelete();
 		vedinsertstring('  ');
 		vedinsertstring(field);
-		vedinsertstring(' = "');
+		vedinsertstring(' = {');
 		if insert_brace then vedcharinsert(`{`) endif;
 		while (vednextline(); strmember(vedcurrentchar(), '\s\t')) do
 			;;; leading space or tab. Treat as continuation
@@ -207,7 +207,7 @@
 		vedcharup();
 		vedtextright();
 		if insert_brace then vedcharinsert(`}`) endif;
-		vedinsertstring('",');
+		vedinsertstring('},');
 	endrepeat;
 	vedlineabove();
 	vedcharinsert(`}`);
@@ -218,6 +218,8 @@
 endsection;
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Apr 14 2009
+		altered to use braces for all lines instead of double quotes.
 --- Aaron Sloman, Feb  8 2003
 	Added URL field
 --- Aaron Sloman, Feb  4 2001
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/vedlatex/auto/ved_dobib.p v15.6301-amd64/pop/packages/vedlatex/auto/ved_dobib.p
--- pp0/v15.61-amd64/pop/packages/vedlatex/auto/ved_dobib.p	2004-08-11 10:30:02.000000000 -0400
+++ v15.6301-amd64/pop/packages/vedlatex/auto/ved_dobib.p	2009-06-24 16:59:18.000000000 -0400
@@ -1,4 +1,4 @@
-/* --- Copyright University of Birmingham 2004. All rights reserved. ------
+/* --- Copyright University of Birmingham 2009. All rights reserved. ------
  > File:			$poplocal/local/ved_latex/auto/ved_latex.p
  > Linked to:		$poplocal/local/ved_latex/auto/ved_dobib.p
  > Linked to:		$poplocal/local/ved_latex/auto/ved_latex2.p
@@ -31,7 +31,7 @@
 lconstant
 	dvi = '.dvi',
 
-	latex_clear = ['.aux' ^dvi '.log' '.bbl' '.blg' '.toc'],
+	latex_clear = ['.aux' ^dvi '.log' '.bbl' '.blg' '.toc' '.out'],
 
 	latex_pr_command = 'dvips -f -t a4 ',
 ;
@@ -633,6 +633,8 @@
 endsection;
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Jun 24 2009
+		Altered latex_clear list to include '.out'
 --- Aaron Sloman, Aug 11 2004
 		Altered latex_quotes to transform "('" to "(`"
 --- Aaron Sloman, Apr 28 2001
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/vedlatex/auto/ved_latex.p v15.6301-amd64/pop/packages/vedlatex/auto/ved_latex.p
--- pp0/v15.61-amd64/pop/packages/vedlatex/auto/ved_latex.p	2004-08-11 10:30:02.000000000 -0400
+++ v15.6301-amd64/pop/packages/vedlatex/auto/ved_latex.p	2009-06-24 16:59:18.000000000 -0400
@@ -1,4 +1,4 @@
-/* --- Copyright University of Birmingham 2004. All rights reserved. ------
+/* --- Copyright University of Birmingham 2009. All rights reserved. ------
  > File:			$poplocal/local/ved_latex/auto/ved_latex.p
  > Linked to:		$poplocal/local/ved_latex/auto/ved_dobib.p
  > Linked to:		$poplocal/local/ved_latex/auto/ved_latex2.p
@@ -31,7 +31,7 @@
 lconstant
 	dvi = '.dvi',
 
-	latex_clear = ['.aux' ^dvi '.log' '.bbl' '.blg' '.toc'],
+	latex_clear = ['.aux' ^dvi '.log' '.bbl' '.blg' '.toc' '.out'],
 
 	latex_pr_command = 'dvips -f -t a4 ',
 ;
@@ -633,6 +633,8 @@
 endsection;
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Jun 24 2009
+		Altered latex_clear list to include '.out'
 --- Aaron Sloman, Aug 11 2004
 		Altered latex_quotes to transform "('" to "(`"
 --- Aaron Sloman, Apr 28 2001
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/vedlatex/auto/ved_latex2.p v15.6301-amd64/pop/packages/vedlatex/auto/ved_latex2.p
--- pp0/v15.61-amd64/pop/packages/vedlatex/auto/ved_latex2.p	2004-08-11 10:30:02.000000000 -0400
+++ v15.6301-amd64/pop/packages/vedlatex/auto/ved_latex2.p	2009-06-24 16:59:18.000000000 -0400
@@ -1,4 +1,4 @@
-/* --- Copyright University of Birmingham 2004. All rights reserved. ------
+/* --- Copyright University of Birmingham 2009. All rights reserved. ------
  > File:			$poplocal/local/ved_latex/auto/ved_latex.p
  > Linked to:		$poplocal/local/ved_latex/auto/ved_dobib.p
  > Linked to:		$poplocal/local/ved_latex/auto/ved_latex2.p
@@ -31,7 +31,7 @@
 lconstant
 	dvi = '.dvi',
 
-	latex_clear = ['.aux' ^dvi '.log' '.bbl' '.blg' '.toc'],
+	latex_clear = ['.aux' ^dvi '.log' '.bbl' '.blg' '.toc' '.out'],
 
 	latex_pr_command = 'dvips -f -t a4 ',
 ;
@@ -633,6 +633,8 @@
 endsection;
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Jun 24 2009
+		Altered latex_clear list to include '.out'
 --- Aaron Sloman, Aug 11 2004
 		Altered latex_quotes to transform "('" to "(`"
 --- Aaron Sloman, Apr 28 2001
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/vedlatex/com/findcites v15.6301-amd64/pop/packages/vedlatex/com/findcites
--- pp0/v15.61-amd64/pop/packages/vedlatex/com/findcites	2008-01-08 15:20:41.000000000 -0500
+++ v15.6301-amd64/pop/packages/vedlatex/com/findcites	2008-05-05 05:00:34.000000000 -0400
@@ -11,12 +11,15 @@
 
 setenv TEXFILE $2
 
+#echo "BIB $1 TEX $2"
+
 #source /bham/common/com/packages/poplog/Login/poplogin
 
 $popsys/basepop11 %noinit << \\\\
 
 ;;; pop11_compile('~axs/temp/findcite.p');
 
+uses vedlatex
 loadlib('findcite.p');
 
 ;;; Global variables needed for scanning the bibtex file analysing it
@@ -56,7 +59,9 @@
 
 ;;; These will be indicators of bibtex citations
 ;;; Added 'citenp' for APA style
-vars citewords = [cite nocite citea citenp citep citet];
+;;; Added citeauthor citeyear for AAAI style
+vars citewords =
+    [cite nocite citea citeA citenp citeNP citep citet citeauthor citeyear];
 
 ;;; convert bibtex types to lower case to simplify matching
 vars bibtypes =
@@ -98,6 +103,8 @@
 
 endif;
 
+;;;cited ==>
+
 process_bib(cited, bibfile);
 
 sysexit();
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/vedmail/auto/ved_Reply.p v15.6301-amd64/pop/packages/vedmail/auto/ved_Reply.p
--- pp0/v15.61-amd64/pop/packages/vedmail/auto/ved_Reply.p	2007-01-30 12:18:32.000000000 -0500
+++ v15.6301-amd64/pop/packages/vedmail/auto/ved_Reply.p	2009-07-07 17:17:39.000000000 -0400
@@ -1,5 +1,5 @@
-/* --- Copyright University of Birmingham 2007. All rights reserved. ------
- > File:            $poplocal/local/auto/ved_reply.p
+/* --- Copyright University of Birmingham 2009. All rights reserved. ------
+ > File:            $usepop/pop/packages/vedmail/auto/ved_reply.p
  > Purpose:			Reply to email message
  > Author:          Aaron Sloman, Updated Sept 1994 (see revisions)
  > Documentation:	See below
@@ -135,14 +135,18 @@
 define lconstant vedgetrest(string) -> string with_props 601;
 	;;; used to get continuation of "To:" or "CC:" line, etc.
 	;;; if next line starts with space or tab
-	lvars string, line;
+	lvars string, line, strings;
 	prune_leader(string) -> string;
 	repeat
 		vednextline();
 		vedthisline() -> line;
 	quitif(vvedlinesize == 0 or strmember(`:`,line)
 			or not(strmember(line(1),'\s\t')));
-		string  sys_>< prune_leader(line) -> string
+	sysparse_string(string) <> sysparse_string(line) -> strings;
+	destpair(strings) -> (string, strings);
+	for line in strings do
+		string  sys_>< vedspacestring sys_>< line -> string
+	endfor;
 	endrepeat;
 enddefine;
 
@@ -154,7 +158,7 @@
 	vedjumpto(lo,1);
 	repeat
 		if vvedlinesize == 0 then false -> found; return() endif;
-		vedthisline() -> found;
+		veddecodetabs(vedthisline()) -> found;
 		if isstring(string) then
 			returnif(isstartstring(string, found));
 		else ;;; string must be a list of strings...
@@ -239,6 +243,8 @@
 		else
 			'Subject: Re: ' sys_>< allbutfirst(9, subject) -> subject
 		endif;
+		vedgetrest(subject) -> subject;
+		;;; Veddebug(subject);
 	else 'Subject: ' -> subject
 	endif
 enddefine;
@@ -296,7 +302,9 @@
 		;;; extract the string and if appropriate, the key
 		if ispair(key) then destpair(field) ->(key, field) endif;
 		;;; remove field stuff from beginning of string
-		allbutfirst(datalength(key), field) -> field
+		allbutfirst(datalength(key), field) -> field;
+    	;;; see if there is a continuation
+	 	vedgetrest(field) -> field;
 	endif;
 	;;; Veddebug([key ^key field ^field]);
 enddefine;
@@ -308,7 +316,7 @@
 enddefine;
 
 define lconstant vedgetreferences(lo,hi) -> references;
-	;;; Get subject from line 'Subject: ...   '
+	;;; Get references from line 'References: ...   '
 	lvars lo,hi,references;
 	vedgetfield(ved_references_field , lo, hi) -> references;
 	;;; Veddebug([references ^references]);
@@ -375,6 +383,7 @@
 		endif;
 	else false -> Cc
 	endif;
+
 	;;; Veddebug(Cc);
 	;;; Find where to start reply
 	if Where = '@t' then lo
@@ -398,7 +407,8 @@
 		unless vvedlinesize == 0 then vedlinebelow() endunless
 	endif;
 	unless vedline==1 then vedlinebelow() endunless;
-	unless vedline >= vvedbuffersize then vedlinebelow(); vedcharup();
+	unless vedline >= vvedbuffersize then
+		vedlinebelow(); vedlinebelow(); vedcharup();
 	endunless;
 	;;; insert 'From ' line to conform to mail format.
 	vedcheck();
@@ -420,18 +430,23 @@
 	vedlinebelow(); vedinsertstring(subject);
 
 	;;; insert messageid
-	vedlinebelow();
-	vedinsertstring(ved_inreplyfield); vedinsertstring(messageid);
+	if messageid then
+		vedlinebelow();
+		vedinsertstring(ved_inreplyfield); vedinsertstring(messageid);
+	endif;
+
 	;;; insert references
-	vedlinebelow();
-	vedinsertstring(ved_references_field);
+	if messageid or references /== nullstring then
+		vedlinebelow();
+		vedinsertstring(ved_references_field);
 		unless datalength(references) == 0 then
-			;;; this may be a null string
 			vedinsertstring(references);
 			vedcharright();
 		endunless;
 		;;; make sure at least messageid is in references field.
-		vedinsertstring(messageid);
+		if messageid then vedinsertstring(messageid) endif;
+
+	endif;
 
 	if Cc then
 		;;; insert copy list
@@ -466,10 +481,10 @@
 				vedtextright(); vedcheck(); vedrefreshrange(vedline,vedline,undef);
 			endif;
 		endif;
-		vedcharup(); vedtextright()
+		vedcharup(); vedtextright();vedmarkhi();
 	endif;
 	if oldc then oldc + 1 else 1 endif -> vedchanged;
-	chain(ved_mcm);
+	chain(ved_mcm<>vedrefresh);
 enddefine;
 
 define global vars procedure ved_reply =
@@ -485,6 +500,11 @@
 nil -> proglist;
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Jul  7 2009
+	Altered to cope with 'wrapped' Subject line.
+--- Aaron Sloman, Feb  7 2007
+	Fixed some problems with continuation lines, and dealt with missing
+	references field	
 --- Aaron Sloman, Jan 30 2007
 	Altered to insert In-Reply-To: field and References: field
 	(Users who don't want them can delete them before sending.)
@@ -543,4 +563,24 @@
 	Simplified vedgetsubject. Made it insert "Re:" after subject, if
 	it isn't already there. Used pdr_valof
 
+         CONTENTS - (Use <ENTER> g to access required sections)
+
+ define lconstant charsbetween(start,fin,string) with_props 501;
+ define lconstant prune_leader(string) -> string;
+ define lconstant prunesitename(string) -> string with_props 505;
+ define lconstant Veddo(vedcommand) with_props 600;
+ define lconstant vedgetrest(string) -> string with_props 601;
+ define lconstant vedtryfind(string,lo,hi) -> found with_props 602;
+ define lconstant vedgetsender(lo,hi) -> line with_props 603;
+ define lconstant vedgetsubject(lo,hi) -> subject with_props 604;
+ define lconstant vedgetCc(lo,hi,) -> Cc with_props 605;
+ define lconstant vedgetTo(lo,hi,) -> string with_props 606;
+ define lconstant vedgetfield(key, lo, hi) -> field;
+ define lconstant vedgetmesssageid(lo,hi) -> messageid;
+ define lconstant vedgetreferences(lo,hi) -> references;
+ define lconstant vedtry(proc,lo,hi);
+ define lconstant veddoreply(all_?) with_props ved_reply;
+ define global vars procedure ved_reply =
+ define global vars procedure ved_Reply =
+
  */
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/vedmail/auto/ved_decode.p v15.6301-amd64/pop/packages/vedmail/auto/ved_decode.p
--- pp0/v15.61-amd64/pop/packages/vedmail/auto/ved_decode.p	2007-02-12 12:28:25.000000000 -0500
+++ v15.6301-amd64/pop/packages/vedmail/auto/ved_decode.p	2008-11-13 15:07:23.000000000 -0500
@@ -1,5 +1,6 @@
-/* --- Copyright University of Birmingham 2007. All rights reserved. ------
- > File:            $poplocal/local/auto/ved_decode.p
+/* --- Copyright University of Birmingham 2008. All rights reserved. ------
+ > File:            $usepop/pop/packages/vedmail/auto/ved_decode.p
+ > previously:            $poplocal/local/auto/ved_decode.p
  > Purpose:			Decode attachment in mail file
  > Author:          Aaron Sloman, Mar 23 1998 (see revisions)
  > Documentation:	See HELP VED_DECODE
@@ -114,6 +115,7 @@
 	jpegtype = '.jpeg',
 	pbmtype  = '.pbm',
 	mpegtype = '.mpeg',
+	mp3type = '.mp3',
 	mpgtype = '.mpg',
 	avitype = '.avi',
 	;;; I don't know what this is!
@@ -135,7 +137,7 @@
 
 	no_decode_types =
 	[^pstype ^htmltype ^htmtype ^texttype ^txttype ^latextype ^bibtype ^rtftype
-			^mpegtype ^mpgtype ^avitype ^pcxtype ^false],
+			^mpegtype ^mp3type ^mpgtype ^avitype ^pcxtype ^false],
 	soffice_types =
 	[^ppttype ^doctype ^xlstype ^htmltype ^sdwtype ^sxwtype ^odttype ^odstype ^odptype],
 	pdf_types = [^pdftype],
@@ -226,6 +228,7 @@
 		;;; next two deal with wrapped lines due to editing name field, etc.
 		or isstartstring('charset=', textline)
 		or isstartstring('name=', textline)
+		or isstartstring('NAME=', textline)
 		or isstartstring('\s', textline)
 		or isstartstring('\t', textline)
 	do
@@ -421,12 +424,16 @@
 	lconstant
 		namestring1 = 'name=',
 		len1 = datalength(namestring1),
+		upnamestring1 = 'NAME=',
 		namestring2 = 'filename=',
 		len2 = datalength(namestring2);
 
 	lvars loc, name = false;
 
-	if content_type and issubstring(namestring1, content_type)->>loc then
+	if content_type and
+			((issubstring(namestring1, content_type)->>loc)
+			or issubstring(upnamestring1, content_type)->>loc)
+		then
 		;;; get name
 		allbutfirst(loc+len1-1, content_type) -> name;
 			
@@ -434,6 +441,8 @@
 		allbutfirst(loc+len2-1, content_disposition) -> name;
 	endif;
 
+	;;; Veddebug('Name: ' >< name);
+
 	if name then
 		if strmember(`;`, name) ->> loc then
 			substring(1, loc - 1, name) -> name;
@@ -559,6 +568,9 @@
 	elseif Isendstring(mpgtype, file_name)
 	then
 		mpgtype -> filetype;
+	elseif Isendstring(mp3type, file_name)
+	then
+		mp3type -> filetype;
 	elseif Issubstring('mpeg', content_type)
 		or Isendstring(mpegtype, file_name)
 	then
@@ -1280,8 +1292,10 @@
 endsection;
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Nov 13 2008
+		allowed mp3 as a category type. Changed file path name.
 --- Aaron Sloman, Feb 12 2007
-	Moved latex type to later, incase it clashes with something
+	Moved latex type to later, in case it clashes with something
 	like Zip type.
 --- Aaron Sloman, Nov 23 2006
 	Altered find_file_type to keep '.txt' for files that already	
